/*
 *  Copyright (c) 2021, WSO2 LLC. (http://www.wso2.org) All Rights Reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */

package logging

import "github.com/sirupsen/logrus"

// Log Level Constants
const (
	defaultLogLevel = logrus.InfoLevel
	panicLevel      = "PANC"
	fatalLevel      = "FATL"
	errorLevel      = "ERRO"
	warnLevel       = "WARN"
	infoLevel       = "INFO"
	debugLevel      = "DEBG"
)

// Log Formalization Constants
const (
	TEXT = "TEXT"
	JSON = "JSON"
)

// Log (Error) severity level constants
const (
	BLOCKER  = "Blocker"
	CRITICAL = "Critical"
	MAJOR    = "Major"
	MINOR    = "Minor"
	TRIVIAL  = "Trivial"
	DEFAULT  = "Default"
)

// Error Log attribute name constants
const (
	SEVERITY  = "severity"
	ERRORCODE = "error_code"
)
