# Errors in Admin Domain Service

These are the admin domain service errors and their respective error codes.

| Error Code | Status Code | Error Message |
|---|---|---|
| 909400  | 500 | Common code for other error |
| 909401  | 500 | Error while retrieving connection |
| 909402  | 500 | Error while inserting data into Database |
| 909403  | 500 | Internal Error occured while retrieving API Categories |
| 909404  | 500 | Error while checking API Category existence |
| 909405  | 500 | Error while updating data record in the Database |
| 909406  | 500 | Error while deleting data record in the Database |
| 909407  | 406 | Invalid query parameters. Only one of the query parameters can be provided |
| 909408  | 500 | Error while inserting vhosts data into Database |
| 909409  | 500 | Error while inserting organization claim data into Database |
| 909410  | 500 | Error while validating organization name in Database |
| 909411  | 500 | Error while validating organization id in Database |
| 909412  | 500 | Error while updating vhosts data into Database |
| 909413  | 500 | Error while updating organization data into Database |
| 909414  | 406 | Organization not found |
| 909415  | 500 | Internal Error occured while retrieving organization data from Database |
| 909416  | 500 | Error while deleting organization data from Database |
| 909417  | 500 | Error while retrieving organization data from Database |
| 909418  | 500 | Error while retrieving Application Usage Plan |
| 909419  | 500 | Internal Error occured while retrieving Application Usage Plans |
| 909420  | 500 | Error while retrieving Business Plan |
| 909421  | 500 | Internal Error occured while retrieving Business Plans |
| 909422  | 500 | Error while retrieving Deny Policy from DB |
| 909423  | 500 | Internal Error occured while retrieving Deny Policies |
| 909424  | 400 | API Category already exists by name: **payloadName** |
| 909425  | 400 | API Category already exists by name: **name** |
| 909426  | 404 | API Category not found |
| 909427  | 409 | Organization already exists by name: **name** |
| 909428  | 400 | Organization ID not exist by: **id** |
| 909429  | 404 | Application Usage Plan not found |
| 909430  | 404 | Business Plan not found |
| 909431  | 404 | Deny Policy not found |
