/*
 * Copyright (c) 2021, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * WSO2 Inc. licenses this file to you under the Apache License,
 * Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.wso2.apk.enforcer.config.dto;

import org.wso2.apk.enforcer.commons.dto.TokenIssuerDto;

/**
 * Holds meta data related to a JWT token issuer.
 */
public class ExtendedTokenIssuerDto extends TokenIssuerDto {
    private String name;
    private boolean validateSubscriptions;
    private String alias;


    public ExtendedTokenIssuerDto(String issuer) {
        super(issuer);
    }

    public boolean isValidateSubscriptions() {
        return validateSubscriptions;
    }

    public void setValidateSubscriptions(boolean validateSubscriptions) {
        this.validateSubscriptions = validateSubscriptions;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCertificateAlias() {
        return alias;
    }

    public void setCertificateAlias(String alias) {
        this.alias = alias;
    }
}

