/*
 * Copyright (c) 2021, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * WSO2 Inc. licenses this file to you under the Apache License,
 * Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.wso2.apk.enforcer.security.jwt.issuer;

import org.apache.commons.codec.binary.Base64;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.wso2.apk.enforcer.commons.exception.JWTGeneratorException;

/**
 * URL safe JWT issuer implementation.
 */
public class URLSafeJWTIssuer extends JWTIssuerImpl {
    private static final Log log = LogFactory.getLog(URLSafeJWTIssuer.class);

    public String encode(byte[] stringToBeEncoded) throws JWTGeneratorException {
        return Base64.encodeBase64URLSafeString(stringToBeEncoded);
    }
}
